package com.eco.plugin.xx.zcgjsync.utils;

import com.eco.plugin.xx.zcgjsync.config.PluginSimpleConfig;

/**
 * 鉴权类
 */
public class AuthUtils {

    /**
     * 鉴权
     * @param token
     * @param now
     * @param psc
     * @throws Exception
     */
    public static void auth(String token,Long now,PluginSimpleConfig psc) throws Exception {
        String privateKey = psc.getPrivatekey();
        String plaintext = EncryptUtils.rsaDecrypt(token,privateKey);
        String[] plainArray = plaintext.split("_");
        String appid = plainArray[0];
        String appKey = plainArray[1];
        Long timestamp = Long.parseLong(plainArray[2]);

        timeout(timestamp,now,psc);

        if(!appid.equals(psc.getClientId()) || !appKey.equals(psc.getSecret())){
            throw new Exception("非法的应用");
        }
    }

    /**
     * 判断token是否超时
     * @param timestatmp
     * @param now
     * @param psc
     * @throws Exception
     */
    private static void timeout(Long timestatmp, Long now, PluginSimpleConfig psc) throws Exception {
        Long timediff = (now - timestatmp) /1000;

        //超时
        if(timediff > psc.getTimeout().intValue()){
            throw new Exception("token 超时");
        }
    }
}
